/*
**	MacroPanel.c
**
**	Editing panel for key macro configuration
**
**	Copyright  1990-1993 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_F1,GAD_F2,GAD_F3,GAD_F4,GAD_F5,GAD_F6,GAD_F7,GAD_F8,GAD_F9,
		GAD_F10,GAD_QUALIFIER,GAD_USE,GAD_LOAD,GAD_SAVE,GAD_CANCEL };

STATIC STRPTR ModifierString[5];

STATIC struct Gadget *
CreateAllGadgets(struct Gadget **GadgetArray,struct Gadget **GadgetList)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	LocalizeString(ModifierString,MSG_MACROPANEL_NONE_TXT,MSG_MACROPANEL_CONTROL_TXT);

	SZ_SizeSetup(Window -> WScreen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_TextWidth("F10") + INTERWIDTH);

		SZ_SetWidth(SZ_Width(STRING_KIND,NULL,60,NULL));

		NewGadget . ng_GadgetText	= "F 1";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 2";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 3";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 4";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 5";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 6";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 7";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 8";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 9";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F10";
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MACROPANEL_KEY_MODIFIER_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AlignCentre,	TRUE,

			GTCY_Labels,	ModifierString,
			GTCY_Active,	0,
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_LOAD_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignBottom,	TRUE,
			SZ_GroupCount,	4,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_LOAD_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SAVE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,
		TAG_DONE);
	}

	return(Gadget);
}

VOID
MacroPanel(struct MacroKeys *MacroKeys)
{
	struct Window		*PanelWindow;
	struct Gadget		*GadgetList = NULL;
	struct Gadget		*GadgetArray[GAD_CANCEL + 1];
	LONG			 i;

	struct MacroKeys	*Keys;

	ULONG			 OldCRC;

	OldCRC = DoCRC(MacroKeys,sizeof(struct MacroKeys));

	if(Keys = (struct MacroKeys *)AllocVec(sizeof(struct MacroKeys),MEMF_ANY|MEMF_CLEAR))
	{
		CopyMem(MacroKeys,Keys,sizeof(struct MacroKeys));

		if(CreateAllGadgets(GadgetArray,&GadgetList))
		{
			if(PanelWindow = OpenWindowTags(NULL,
				WA_Left,	GetScreenLeft(Window) + (GetScreenWidth(Window) - SZ_GetWindowWidth()) / 2,
				WA_Top,		GetScreenTop(Window) + (GetScreenHeight(Window) - SZ_GetWindowHeight())	/ 2,
				WA_Width,	SZ_GetWindowWidth(),
				WA_Height,	SZ_GetWindowHeight(),

				WA_Activate,	TRUE,
				WA_DragBar,	TRUE,
				WA_DepthGadget,	TRUE,
				WA_CloseGadget,	TRUE,
				WA_RMBTrap,	TRUE,
				WA_DepthGadget,	TRUE,
				WA_CustomScreen,Window -> WScreen,

				WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_CLOSEWINDOW | IDCMP_RAWKEY | IDCMP_VANILLAKEY | IDCMP_ACTIVEWINDOW | BUTTONIDCMP | CYCLEIDCMP | STRINGIDCMP,

				WA_Title,	LocaleString(MSG_MACROPANEL_MACRO_PREFERENCES_TXT),
			TAG_DONE))
			{
				struct IntuiMessage	*Massage;
				ULONG			 IClass,Code;
				struct Gadget		*Gadget;
				BYTE			 Terminated = FALSE;

				UBYTE			 DummyBuffer[MAX_FILENAME_LENGTH],
							*DummyChar;

				struct FileRequester	*FileRequest;

				LONG			 Modifier = 0;

				GuideContext(CONTEXT_MACROS);

				PushWindow(PanelWindow);

				AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
				RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
				GT_RefreshWindow(PanelWindow,NULL);

				if(XEmulatorBase && Config -> TerminalConfig -> EmulationMode == EMULATION_EXTERNAL)
				{
					ULONG KeyMask = XEmulatorGetFreeMacroKeys(XEM_IO,Modifier);

					for(i = 0 ; i < 10 ; i++)
					{
						GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
							GTST_String,	Keys -> Keys[Modifier][i],
							GA_Disabled,	!(KeyMask & (1 << i)),
						TAG_DONE);
					}
				}
				else
				{
					for(i = 0 ; i < 10 ; i++)
					{
						GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
							GTST_String,Keys -> Keys[Modifier][i],
						TAG_DONE);
					}
				}

				ActiveGadget = NULL;

				ClrSignal(SIG_BREAK);

				while(!Terminated)
				{
					if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
					{
						CopyMem(Keys,MacroKeys,sizeof(struct MacroKeys));

						break;
					}

					while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
					{
						IClass	= Massage -> Class;
						Code	= Massage -> Code;
						Gadget	= (struct Gadget *)Massage -> IAddress;

						GT_ReplyIMsg(Massage);

						if(IClass == IDCMP_ACTIVEWINDOW && ActiveGadget)
							ActivateGadget(ActiveGadget,PanelWindow,NULL);

						KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&IClass,&Code);

						if(IClass == IDCMP_GADGETDOWN)
						{
							if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
								ActiveGadget = Gadget;
						}

						if(IClass == IDCMP_CLOSEWINDOW)
						{
							CopyMem(Keys,MacroKeys,sizeof(struct MacroKeys));

							Terminated = TRUE;
						}

						if(IClass == IDCMP_GADGETUP)
						{
							switch(Gadget -> GadgetID)
							{
								case GAD_QUALIFIER:

									for(i = 0 ; i < 10 ; i++)
										strcpy(Keys -> Keys[Modifier][i],SZ_GetString(GadgetArray[i]));

									Modifier = Code;

									if(XEmulatorBase && Config -> TerminalConfig -> EmulationMode == EMULATION_EXTERNAL)
									{
										ULONG KeyMask = XEmulatorGetFreeMacroKeys(XEM_IO,Modifier);

										ActiveGadget = NULL;

										for(i = 0 ; i < 10 ; i++)
										{
											GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
												GTST_String,	Keys -> Keys[Modifier][i],
												GA_Disabled,	!(KeyMask & (1 << i)),
											TAG_DONE);

											if((KeyMask & (1 << i)) && !ActiveGadget)
												ActiveGadget = GadgetArray[GAD_F1 + i];
										}

										if(ActiveGadget)
											ActivateGadget(ActiveGadget,PanelWindow,NULL);
									}
									else
									{
										for(i = 0 ; i < 10 ; i++)
										{
											GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
												GTST_String,Keys -> Keys[Modifier][i],
											TAG_DONE);
										}
									}

									break;

								case GAD_USE:

									Terminated = TRUE;

									for(i = 0 ; i < 10 ; i++)
										strcpy(Keys -> Keys[Modifier][i],SZ_GetString(GadgetArray[i]));

									CopyMem(Keys,MacroKeys,sizeof(struct MacroKeys));

									break;

								case GAD_LOAD:

									strcpy(DummyBuffer,LastMacros);

									DummyChar = PathPart(DummyBuffer);

									*DummyChar = 0;

									BlockWindow(PanelWindow);

									if(FileRequest = GetFile(LocaleString(MSG_MACROPANEL_LOAD_MACRO_KEYS_TXT),DummyBuffer,FilePart(LastMacros),DummyBuffer,"#?.prefs",FALSE,FALSE,FALSE,LocaleString(MSG_GLOBAL_LOAD_TXT),TRUE))
									{
										if(!LoadMacros(DummyBuffer,Keys))
											MyEasyRequest(Window,LocaleString(MSG_MACROPANEL_COULD_NOT_LOAD_MACRO_KEYS_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),DummyBuffer);
										else
										{
											MacroChanged = FALSE;

											OldCRC = DoCRC(Keys,sizeof(struct MacroKeys));

											strcpy(Config -> FileConfig -> MacroFileName,DummyBuffer);

											strcpy(LastMacros,DummyBuffer);

											for(i = 0 ; i < 10 ; i++)
											{
												GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
													GTST_String,Keys -> Keys[Modifier][i],
												TAG_DONE);
											}
										}

										FreeAslRequest(FileRequest);
									}

									ReleaseWindow(PanelWindow);

									break;

								case GAD_SAVE:

									strcpy(DummyBuffer,LastMacros);

									DummyChar = PathPart(DummyBuffer);

									*DummyChar = 0;

									BlockWindow(PanelWindow);

									for(i = 0 ; i < 10 ; i++)
										strcpy(Keys -> Keys[Modifier][i],SZ_GetString(GadgetArray[i]));

									if(FileRequest = GetFile(LocaleString(MSG_MACROPANEL_SAVE_MACRO_KEYS_TXT),DummyBuffer,FilePart(LastMacros),DummyBuffer,"#?.prefs",TRUE,FALSE,FALSE,LocaleString(MSG_GLOBAL_SAVE_TXT),TRUE))
									{
										if(!WriteIFFData(DummyBuffer,Keys,sizeof(struct MacroKeys),ID_KEYS))
											MyEasyRequest(Window,LocaleString(MSG_MACROPANEL_COULD_NOT_SAVE_MACRO_KEYS_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),DummyBuffer);
										else
										{
											strcpy(LastMacros,DummyBuffer);

											MacroChanged = FALSE;

											OldCRC = DoCRC(Keys,sizeof(struct MacroKeys));
										}

										FreeAslRequest(FileRequest);
									}

									ReleaseWindow(PanelWindow);

									break;

								case GAD_CANCEL:

									Terminated = TRUE;

									CopyMem(Keys,MacroKeys,sizeof(struct MacroKeys));

									break;
							}
						}
					}
				}

				RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

				PopWindow();

				CloseWindow(PanelWindow);
			}
		}

		FreeGadgets(GadgetList);

		FreeVec(Keys);
	}

	MacroChanged |= (OldCRC != DoCRC(MacroKeys,sizeof(struct MacroKeys)));
}
